package com.datacloudsec.utils;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.security.Security;
import java.security.spec.InvalidKeySpecException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.PBEKeySpec;
import javax.crypto.spec.PBEParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import org.apache.commons.io.FileUtils;
import org.apache.commons.io.IOUtils;
import org.bouncycastle.jce.provider.BouncyCastleProvider;
import sun.misc.BASE64Decoder;

public class WebLogicPwdDecryptor {

   public static void main(String[] args) throws Exception {
      Map s = exec(new File("d:/test/boot.properties"), new File("d:/test/SerializedSystemIni.dat"));
      System.out.println(s);
   }

   public static Map exec(File pro, File dat) throws Exception {
      Security.addProvider(new BouncyCastleProvider());
      List boots = FileUtils.readLines(pro, "UTF-8");
      HashMap result = new HashMap();
      Iterator var5 = boots.iterator();

      while(var5.hasNext()) {
         String boot = (String)var5.next();
         if(boot.startsWith("username=") || boot.startsWith("password=")) {
            String ciphertext = boot.substring(boot.indexOf("=") + 1, boot.length());
            String cleartext = "";
            if(ciphertext.startsWith("{AES}")) {
               ciphertext = ciphertext.replaceAll("^[{AES}]+", "");
               cleartext = decryptAES(dat.getAbsolutePath(), ciphertext);
            } else if(ciphertext.startsWith("{3DES}")) {
               ciphertext = ciphertext.replaceAll("^[{3DES}]+", "");
               cleartext = decrypt3DES(dat.getAbsolutePath(), ciphertext);
            }

            result.put(boot.substring(0, boot.indexOf("=")), cleartext);
         }
      }

      return result;
   }

   public static String decryptAES(String SerializedSystemIni, String ciphertext) throws NoSuchAlgorithmException, InvalidKeySpecException, NoSuchPaddingException, InvalidAlgorithmParameterException, InvalidKeyException, BadPaddingException, IllegalBlockSizeException, IOException {
      byte[] encryptedPassword1 = (new BASE64Decoder()).decodeBuffer(ciphertext);
      Object salt = null;
      byte[] encryptionKey = null;
      String key = "0xccb97558940b82637c8bec3c770f86fa3a391a56";
      char[] password = new char[key.length()];
      key.getChars(0, password.length, password, 0);
      FileInputStream is = new FileInputStream(SerializedSystemIni);

      byte[] salt1;
      try {
         salt1 = readBytes(is);
         int keyFactory = is.read();
         if(keyFactory != -1) {
            encryptionKey = readBytes(is);
            if(keyFactory >= 2) {
               encryptionKey = readBytes(is);
            }
         }
      } finally {
         IOUtils.closeQuietly(is);
      }

      SecretKeyFactory keyFactory1 = SecretKeyFactory.getInstance("PBEWITHSHAAND128BITRC2-CBC");
      PBEKeySpec pbeKeySpec = new PBEKeySpec(password, salt1, 5);
      SecretKey secretKey = keyFactory1.generateSecret(pbeKeySpec);
      PBEParameterSpec pbeParameterSpec = new PBEParameterSpec(salt1, 0);
      Cipher cipher = Cipher.getInstance("PBEWITHSHAAND128BITRC2-CBC");
      cipher.init(2, secretKey, pbeParameterSpec);
      SecretKeySpec secretKeySpec = new SecretKeySpec(cipher.doFinal(encryptionKey), "AES");
      byte[] iv = new byte[16];
      System.arraycopy(encryptedPassword1, 0, iv, 0, 16);
      int encryptedPasswordlength = encryptedPassword1.length - 16;
      byte[] encryptedPassword2 = new byte[encryptedPasswordlength];
      System.arraycopy(encryptedPassword1, 16, encryptedPassword2, 0, encryptedPasswordlength);
      IvParameterSpec ivParameterSpec = new IvParameterSpec(iv);
      Cipher outCipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
      outCipher.init(2, secretKeySpec, ivParameterSpec);
      byte[] cleartext = outCipher.doFinal(encryptedPassword2);
      return new String(cleartext, "UTF-8");
   }

   public static String decrypt3DES(String SerializedSystemIni, String ciphertext) throws NoSuchAlgorithmException, InvalidKeySpecException, NoSuchPaddingException, InvalidAlgorithmParameterException, InvalidKeyException, BadPaddingException, IllegalBlockSizeException, IOException {
      byte[] encryptedPassword1 = (new BASE64Decoder()).decodeBuffer(ciphertext);
      Object salt = null;
      byte[] encryptionKey = null;
      String PW = "0xccb97558940b82637c8bec3c770f86fa3a391a56";
      char[] password = new char[PW.length()];
      PW.getChars(0, password.length, password, 0);
      FileInputStream is = new FileInputStream(SerializedSystemIni);

      byte[] salt1;
      try {
         salt1 = readBytes(is);
         int keyFactory = is.read();
         if(keyFactory != -1) {
            encryptionKey = readBytes(is);
            if(keyFactory >= 2) {
               encryptionKey = readBytes(is);
            }
         }
      } finally {
         IOUtils.closeQuietly(is);
      }

      SecretKeyFactory keyFactory1 = SecretKeyFactory.getInstance("PBEWITHSHAAND128BITRC2-CBC");
      PBEKeySpec pbeKeySpec = new PBEKeySpec(password, salt1, 5);
      SecretKey secretKey = keyFactory1.generateSecret(pbeKeySpec);
      PBEParameterSpec pbeParameterSpec = new PBEParameterSpec(salt1, 0);
      Cipher cipher = Cipher.getInstance("PBEWITHSHAAND128BITRC2-CBC");
      cipher.init(2, secretKey, pbeParameterSpec);
      SecretKeySpec secretKeySpec = new SecretKeySpec(cipher.doFinal(encryptionKey), "DESEDE");
      byte[] iv = new byte[8];
      System.arraycopy(salt1, 0, iv, 0, 4);
      System.arraycopy(salt1, 0, iv, 4, 4);
      IvParameterSpec ivParameterSpec = new IvParameterSpec(iv);
      Cipher outCipher = Cipher.getInstance("DESEDE/CBC/PKCS5Padding");
      outCipher.init(2, secretKeySpec, ivParameterSpec);
      byte[] cleartext = outCipher.doFinal(encryptedPassword1);
      return new String(cleartext, "UTF-8");
   }

   public static byte[] readBytes(InputStream stream) throws IOException {
      int length = stream.read();
      byte[] bytes = new byte[length];

      int justread;
      for(int in = 0; in < length; in += justread) {
         justread = stream.read(bytes, in, length - in);
         if(justread == -1) {
            break;
         }
      }

      return bytes;
   }
}
